package com.p3p.serialecho;

import com.p3p.serialecho.packets.TestPacket;
import com.p3p.simpleserialprotocol.SerialPacket;
import com.p3p.simpleserialprotocol.SimpleSerialProtocol;

public class SerialEcho {
	
	public static SimpleSerialProtocol comms;
	public static void main(String[] args) {
		String comport = args[0];
		int baudrate = Integer.parseInt(args[1]);
		
		comms = new SimpleSerialProtocol(comport, baudrate);
		
		long start = System.nanoTime();
		
		comms.start();
		while(true){
			SerialPacket packet = comms.poll();
			
			if(comms.getSendQueueSize() < 2){
				SerialPacket send_packet = new SerialPacket(new TestPacket(1,0,0,0,0.0f).encodePacket());
				comms.send(send_packet);
			}
				
			if((System.nanoTime() - start)/1000000 > 1000){
				start = System.nanoTime();
				System.out.printf("%dB/s in, %dB/s out, %d P/in, %d P/out, %d in Buffer\r", comms.getBpsIn(), comms.getBpsOut(), comms.getReceivedPackets(), comms.getSentPackets(), comms.getSendQueueSize());
			}
			try {
				Thread.sleep(1);
			} catch (InterruptedException e) {
				e.printStackTrace();
				break;
			}
		}
    }
}